---
title: XRRigidTransform()
slug: Web/API/XRRigidTransform/XRRigidTransform
tags:
  - API
  - AR
  - Constructor
  - Mixed Reality
  - Orientation
  - Position
  - Reality
  - Reference
  - VR
  - Virtual
  - WebXR
  - XR
  - XRRigidTransform
  - augmented
  - transform
---
<div>{{APIRef("WebXR Device API")}}</div>

<p><span class="seoSummary">The <strong><code>XRRigidTransform</code><code>()</code></strong> constructor creates and returns a new {{domxref("XRRigidTransform")}} object, representing the position and orientation of a point or object.</span> Among other things, <code>XRRigidTransform</code> is used when providing a transform to translate between coordinate systems across spaces.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">let <em>xrRigidTransform</em> = new XRRigidTransform(<em>position</em>, <em>orientation</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>position</code> {{optional_inline}}</dt>
 <dd>An object conforming to {{domxref("DOMPointInit")}} which specifies the coordinates at which the point or object is located. These dimensions are specified in meters. If this parameter is left out or is not compatible with <code>DOMPointInit</code>,  the position used is assumed to be <code>{x: 0, y: 0, z: 0, w: 1}</code>. <code>w</code> must <em>always</em> be 1.</dd>
 <dt><code>orientation</code> {{optional_inline}}</dt>
 <dd>An object conforming to {{domxref("DOMPointInit")}} which specifies the direction in which the object is facing. The default value for <code>orientation</code> is <code>{x: 0, y: 0, z: 0, w: 1}</code>. The specified orientation gets normalized if it's not already.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A new {{domxref("XRRigidTransform")}} object which has been initialized to represent a transform matrix that would adjust the position and orientation of an object from the origin to the specified <code>position</code> and facing in the direction indicated by <code>orientation</code>.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>TypeError</code></dt>
 <dd>The value of the <code>w</code> coordinate in the specified <code>position</code> is not 1.0.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>In this example, the beginning of the animation of a scene is shown, starting with a request for a reference space of a given type, then shifting the coordinate system based on a transform before requesting the first animation frame.</p>

<pre class="brush: js notranslate">let animationFrameRequestID = 0;

xrSession.requestReferenceSpace("local-floor")
.then((refSpace) =&gt; {
  xrReferenceSpace = refSpace.getOffsetReferenceSpace(
        new XRRigidTransform(viewerPosition, viewerOrientation));
  animationFrameRequestID = xrSession.requestAnimationFrame(drawFrame);
});</pre>

<p>After requesting a reference space of type <code>local-floor</code>, the returned promise is eventually resolved, at which time we receive a new reference space object, <code>refSpace</code>. After creating an <code>XRRigidTransform</code> from the viewer's initial position and orientation, we pass the new transform into {{domxref("XRReferenceSpace.getOffsetReferenceSpace", "getOffsetReferenceSpace()")}} to create <em>another</em> reference space, now offset so that its origin is located at the same place in space as the coordinates given by <code>viewerPosition</code>, with the orientation also revised in the same fashion.</p>

<p>Then {{domxref("XRSession.requestAnimationFrame", "requestAnimationFrame()")}} is called to ask for a new animation frame to draw into. The <code>drawFrame()</code> callback will be executed when the system is ready to draw the next frame.</p>

<p>You can find more examples in <a href="/en-US/docs/Web/API/WebXR_Device_API/Movement_and_motion">Movement, orientation, and motion</a>.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#dom-xrrigidtransform-xrrigidtransform","XRRigidTransform()")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.XRRigidTransform.XRRigidTransform")}}</div>
